config/routes.rb
Rails.application.routes.draw do
  get 'properties/new'
  
  root                       'pages#home'
  get    'about'          => 'pages#about'
  get    'search'         => 'properties#index'
  get    'register'       => 'users#new'
  get    'login'          => 'sessions#new'
  post   'login'          => 'sessions#create'
  delete 'logout'         => 'sessions#destroy'
  get    'properties/new' => 'properties#new'
  get    'properties/:id/review' => 'reviews#new'
  resources :users
  resources :account_activations, only: [:edit]
  resources :properties
  resources :comments,            only: [:create, :destroy]
  resources :reviews,            only: [:new , :create, :destroy]
end

app/models/property.rb
require 'carrierwave/orm/activerecord'

class Property < ActiveRecord::Base
    mount_uploader :img, ImgUploader
    has_many :comments, dependent: :destroy
    has_many :property_questions
    has_many :reviews
    validates :addressLine1, presence: true, length: {maximum: 30}
    validates :addressLine2,  length: {maximum: 30}
    validates :town, presence: true, length: {maximum: 50}
    validates :postcode, presence: true, length: {maximum: 8}
end

app/controllers/properties_controller.rb
class PropertiesController < ApplicationController
  before_action :logged_in_user, only: []
  before_action :correct_user,   only: []
  before_action :admin_user,     only: [:new]
  
  def index
    if params[:q].present?
      @properties = Property.where("postcode LIKE :query OR town LIKE :query OR addressLine1 LIKE :query", {query: "%#{params[:q]}%"}).paginate(page: params[:page])
      @title = "Search results for #{params[:q]}"
    else
      @title = "All properties"
      @properties = Property.paginate(page: params[:page])
    end
  end
  
  def new
    @property = Property.new
    @user = User.find(current_user)
  end
  
  def show
    @property = Property.find(params[:id])
    @user = User.find(current_user) if logged_in?
    @comments = @property.comments.paginate(page: params[:comments_page], per_page: 6)
    @comment = @property.comments.build if logged_in?
    
    @reviews = @property.reviews.paginate(page: params[:reviews_page], per_page: 6)
  end
  
  def create 
    @property = Property.new(property_params)
    if @property.save 
      redirect_to root_url
    end  
    
  end
  
  def update 
    if @property.update_attributes(property_params)
      flash[:success] = "Property updated!"
    end
  end
  
  def destroy
    Property.find(params[:id]).destroy
    flash[:success] = "Property removed!"
    redirect_to root_url
  end
  
  private
    def property_params
      params.require(:property).permit(:addressLine1, :addressLine2,:county ,:town, :postcode, :img)
    end
    
    #Before filters
    
    #Confirms a logged-in user.
    def logged_in_user
      unless logged_in?
        store_location
        flash[:danger] = "Please log in."
        redirect_to login_url
      end
    end

    #Confirms the correct user.
    def correct_user
      @user = User.find(params[:id])
      redirect_to(root_url) unless current_user?(@user)
    end
    
    def admin_user
      redirect_to(properties_path) unless current_user.admin?
    end
end

app/helpers/properties_helper.rb
module PropertiesHelper
end

app/views/properties/_property.html.erb
<li class="property">
    <% if not property.img.blank? %>
        <div class="box_image">
            <img src="<%= property.img %>" alt="Property Thumbnail">
        </div>
    <% end %>
    <div class="property_content">
        <% rating = average_rating(property) %>
        <%= link_to property.addressLine1, property, { class: "title" } %>
        <% if rating == -1 %>
            <div>No ratings for this property</div>
        <% else %>
            <div class="rating">Average rating: <span><%= rating %></span></div>
        <% end %>
    </div>
</li>

app/views/properties/index.html.erb
<% provide(:title, @title) %>
<div class="center_box">
  <h1><%= @title %> (<%= @properties.length %>)</h1>
  <div class="property_search">
    <div class="searchbox">
        <div class="searchbar">
            <%= render 'shared/searchbox' %>
        </div>
    </div>
  </div>
  
  <%= will_paginate %>
  <ul class="results">
    <%= render @properties %>
  </ul>
  <%= will_paginate %>
</div>

app/views/properties/new.html.erb
<% provide(:title, "Add Property") %>
<div id=bimage>
<div id="overlay">
  <div id="form_container">
    <div class="form_title">Add property</div>
    <%= form_for(@property) do |f| %>
      <div class="text_input not_empty_validator">
        <%= f.label :addressLine1, "Address line 1" %>
        <%= f.text_field :addressLine1, placeholder: "Address line 1" %>
      </div>
      <div class="text_input not_empty_validator">
        <%= f.label :addressLine2, "Address line 2" %>
        <%= f.text_field :addressLine2, placeholder: "Address line 2" %>
      </div>
      <div class="text_input not_empty_validator">
      <%= f.label :town, "Town" %>
      <%= f.text_field :town, placeholder: "Town" %>
      </div>
      <div class="text_input not_empty_validator">
        <%= f.label :county, "County" %>
        <%= f.text_field :county, placeholder: "County" %>
      </div>
      <div class="text_input postcode_validator">
        <%= f.label :postcode, "Postcode" %>
        <%= f.text_field :postcode, placeholder: "Postcode" %>
        <span class="info"></span>
      </div>
      
       <%= f.label "Image" %>
      <%= f.file_field :img, multiple: false %>
      
      <%= f.submit "Add", class: "raised main" %>
    <% end %>
    </div>
  </div>
</div>
</div>

app/views/properties/show.html.erb
<% provide(:title, @property.addressLine1) %>
<div class="center_box">
    <div class="col">
        <div class="info_box">
            <div class="box_title main"><%= @property.addressLine1 %></div>
            <div class="box_content">
                <% if not @property.img.blank? %>
                    <div class="box_image">
                        <img src="<%= @property.img %>" alt="Property Thumbnail">
                    </div>
                <% end %>
                <div class="property_address">
                    <%= @property.addressLine1 %><br>
                    <%= @property.addressLine2 %><br>
                    <%= @property.town %><br>
                    <%= @property.county %><br>
                    <%= @property.postcode %><br>
                    <% rating = average_rating(@property) %>
                    <% if rating >= 0 %>
                        <hr>
                        <div class="rating">Average rating: <span><%= rating %></span></div>
                    <% end %>
                </div>
            </div>
        </div>
        <div class="info_box">
            <div class="box_title">Reviews (<%= @reviews.count %>)</div>
            <% if @reviews.any? %>
                <ol class="reviews_list">
                    <%= render @reviews %>
                </ol>
                <%= will_paginate @reviews, param_name: 'reviews_page' %>
            <% end %>
            <% if logged_in? %>
                <%= link_to "Add a review", new_review_url(id: @property.id), { class: "comment_login link" } %>
            <% end %>
        </div>
    </div><!-- removing the white space between these two divs
 --><div class="col">
        <div class="info_box">
            <div class="box_title">Comments (<%= @comments.count %>)</div>
                <% if logged_in? %>
                    <button class="comment_login link">Write a comment</button>
                    <%= form_for(@comment, html: { class: "comment_form hidden" }) do |f| %>
                        <%= render 'shared/error_messages', object: f.object %>
                        <div class="field">
                            <%= f.hidden_field :user_id, :value     => @user.id %>
                            <%= f.hidden_field :property_id, :value => @property.id %>
                            <div id="fld_comment">
                                <%= f.label :content, "Write a comment:" %>
                                <%= f.text_area :content, placeholder: "Comment", rows: 6 %>
                                <span class="info"></span>
                            </div>
                            <%= f.submit "Post", class: "raised" %>
                            <button class="raised cancel">Cancel</button>
                        </div>
                    <% end %>
                <% else %>
                    <%= link_to "Login to write a comment", login_url, class: "comment_login link" %>
                <% end %>
                <% if @comments.any? %>
                    <ol class="comments_list">
                        <%= render @comments %>
                    </ol>
                    <%= will_paginate @comments, param_name: 'comments_page' %>
                <% end %>
            </div>
        </div>
    </div>
</div>